﻿using System;
using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Documents.Spreadsheet.Model;

namespace WorkbookCopy
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void ReplaceWorkbookWithCopy(object sender, RoutedEventArgs e)
        {
            Workbook oldWorkbook = this.spreadsheetControl.RadSpreadsheet.Workbook;
            Workbook newWorkbook = this.CreateWorkbookCopy(oldWorkbook);

            this.spreadsheetControl.RadSpreadsheet.Workbook = newWorkbook;
        }

        private Workbook CreateWorkbookCopy(Workbook sourceWorkbook)
        {
            Workbook targetWorkbook = new Workbook();

            foreach (Worksheet worksheet in sourceWorkbook.Worksheets)
            {
                this.CreateWorksheetCopy(targetWorkbook, worksheet);
            }

            targetWorkbook.Theme = sourceWorkbook.Theme;

            return targetWorkbook;
        }

        private void CreateWorksheetCopy(Workbook workbook, Worksheet sourceWorksheet)
        {
            Worksheet targetWorksheet = workbook.Worksheets.Add();
            CellRange usedCellRange = sourceWorksheet.UsedCellRange;
            WorksheetFragment fragment = sourceWorksheet.Cells[usedCellRange].Copy();
            targetWorksheet.Cells[0, 0].Paste(fragment, PasteOptions.All);
        }
    }
}
